#include <stdio.h>
#include <stdlib.h>
#include "piece.h"

struct piece_s {
  int x,y;
  bool small;
  bool horizontal;
};
  
struct cpiece_s {
  piece *piece;
};

piece new_piece_rh(int x, int y, bool small, bool horizontal) {
  piece point;
  point = malloc(sizeof(* point));
  point->x = x;
  point->y = y;
  point->small = small;
  point->horizontal = horizontal;
  return point;
}

void delete_piece(piece p) {
  free(p);
}

void copy_piece(cpiece src, piece dst) {
  //copie des elements de la piece src vers la piece dst
  dst->x = src->x;
  dst->y = src->y;
  dst->small = src->small;
  dst->horizontal = src->horizontal;
}

void move_piece(piece p, dir d, int distance) {
  bool horizontal = is_horizontal(p);
  if(horizontal) { //on effectue le mouvement gauche ou droit
    if(d == LEFT)
      p->x -= distance;
    if(d == RIGHT)
      p->x += distance;
  }
  else { //on effectue le mouvement bas ou haut
    if(d == DOWN)
      p->y -= distance;
    if(d == UP)
      p->y += distance;
  }
}

bool intersect(cpiece p1, cpiece p2) {
  int x1 = get_x(p1); 
  int y1 = get_y(p1); 
  int h1 = get_height(p1) - 1; //hauteur supplémentaire de la hauteur de base(1) de p1
  int w1 = get_width(p1) - 1; //longueur sans la longueur de base de p1
  int x2 = get_x(p2); 
  int y2 = get_y(p2); 
  int h2 = get_height(p2) - 1; //hauteur supplémentaire de p2
  int w2 = get_width(p2) - 1; //longueur supplémentaire de p2

  if(is_horizontal(p1)) { //si p1 est horizontal
    if(is_horizontal(p2)) {
      for(int i = x1; i <= (x1 + w1); ++ i) { //pour la largeur de p1
	for(int j = x2; j <= (x2 + w2); ++ j) { //pour la largeur de p2
	  if(j == i && y1 == y2) //si largeur en commum et même y dans la grille
	    return true;
	}
      }
    }
    else { //si p2 est verticale
      for(int i = y2; i <= (y2 + h2); ++ i) { //pour la hauteur de p2
	if(y1 == i) { //si hauteur de p1 est égale
	  for(int j = x1; j <= (x1 + w1); ++ j) { //pour la largeur de p1
	    if(x2 == j) //et si même x que p2
	      return true;
	  }
	}
      }
    }
  }
  else { //si p1 est verticale
    if(is_horizontal(p2)) {
      for(int i = y1; i <= (y1 + h1); ++ i) { 
	if(y2 == i) { //si hauteur de p2 est égale
	    for(int j = x2; j <= (x2 + w2); ++ j) {
	      if(x1 == j) //et si même x que p2
		return true;
	    }
	}
      }
    }
    else { //si p2 est verticale
      for(int i = y1; i <= (y1 + h1); ++ i) {
	for(int j = y2; j <= (y2 + h2); ++ j) {
	  if(j == i && x1 == x2) //si hauteur en commum et x dans la grille
	    return true;
	}
      }
    }
  }
  return false;
}

int get_x(cpiece p) {
  return p->x;
}


int get_y(cpiece p) {
  return p->y;
}

int get_height(cpiece p) {
  if(is_horizontal(p)) //si p horizontale, hauteur = 1
    return 1;
  if(p->small)
    return 2;
  return 3;
}

int get_width(cpiece p) {
  if(is_horizontal(p)) {
    if(p->small)
      return 2;
    if(!(p->small))
      return 3;
  }
  return 1; //si p verticale, longueur = 1
}

bool is_horizontal(cpiece p) {
  return p->horizontal;
}

